module TAK2HATA
module SU2MITSUBA
module SU2OBJMTL
	def find_render()
		execname = "EXE|*.exe"
		#execname = File.basename(@render_path,".exe")
		render_path=UI.openpanel("Locate Render(#{execname})","","*.exe")
		if render_path and FileTest.exist?(render_path)
			@render_path = render_path
			##@render_path.gsub!(/\\/,"/")
			@render_path.gsub!(/\\/, File::SEPARATOR )
			#@wdlg.execute_script("document.getElementById('render_engin').value='#{@render_path}';")
			return true
		else
			return false
		end
	end
	def render_check()
		if @render_path and FileTest.exist?(@render_path)
			return true
		else
			status = find_render()
			save_render_path_ini()
			return status
		end
	end
	def save_render_path_ini(rsiname = "Mitsuba_Render_Exporter")
		Sketchup.write_default(rsiname,"RenderPath",@render_path.unpack("H*"))
	end
	def get_render_path_ini(opendialog = true,rsiname = "Mitsuba_Render_Exporter")
		filepath_arr = Sketchup.read_default(rsiname,"RenderPath",[])
		if filepath_arr == []
			if opendialog == true
			if find_render()
				save_render_path_ini()
			end
			end
			return
		end
		
		begin
			@render_path = filepath_arr.pack("H*")
		rescue
			@render_path = ""
		end

	end

######

	def all_init
		@msgtime = Time.now.to_f
		@objcount = 0
		get_render_path_ini()
		buffer_init()
		
		#folder_setup()
	end
 	def folder_setup()
		model_name = Sketchup.active_model.path.length > 2 ? ((Sketchup.active_model.title).gsub(/\s/, "_")) : "untitled"
		if RUBY_PLATFORM[/darwin/]
			mtsfolder=File.join( ( File.expand_path("~/Documents") ),"mitsuba")
			srfolder=File.join( mtsfolder ,"su_render")
			create_foder(mtsfolder)
			create_foder(srfolder)
			@export_dir = File.join( srfolder, (model_name.to_s))
			@outputdir = File.join( @export_dir, "output" )
			@previewdir = File.join( @export_dir , "preview_cash" )
			@texture_exportpath = File.join( @export_dir , "tx_default" )
		else
			@export_dir = File.join(File.dirname(@render_path) , "su_render")
			@outputdir = File.join( @export_dir, "output")
			@previewdir = File.join( @export_dir , "preview_cash" )
			@texture_exportpath = File.join( @export_dir , "tx_default" )
		end
		#
		#Dir::chdir(File.dirname(@render_path))
		create_foder(@export_dir)
		Dir::chdir(File.dirname(@export_dir))
		create_foder(@outputdir)
		create_foder(@previewdir)
		create_foder(@texture_exportpath)
	end
	def create_foder(dirpath)
	  if dirpath and dirpath != ""
		 if not FileTest.exist?(dirpath)
			#if RUBY_PLATFORM[/darwin/]
			#	require "fileutils"
			#	FileUtils::mkdir_p(dirpath)
			#else
			Dir.mkdir(dirpath)
			#end
		 end
	  end
	end

	def time_check_status( msg , status )
		if ( Time.now.to_f - @msgtime ) >= 0.5
			@msgtime = Time.now.to_f
			Sketchup.set_status_text "#{msg}:#{status}"
		end
		
	end
	def buffer_init
		@obj_list = {}# if not @obj_list
		@s2v_model_textures = []# if not @model_textures
		@s2v_used_material = []
		@t2h_stored_lights = []
		#@material_list = Sketchup.materials

	end
	
	def export_obj()
		create_storing_hashes()
		@component_store = {}
		@instance_store = []
		@matnamelist = {}
		#title = @title
		ents = Sketchup.active_model.entities

		Sketchup.set_status_text "export main mesh"
		#t = Geom::Transformation.axes( Geom::Point3d.new(0,0,0), Geom::Vector3d.new(1,0,0), Geom::Vector3d.new(0,1,0), Geom::Vector3d.new(0,0,1) )
		t = Geom::Transformation.new
		cdf = Sketchup.active_model
		movec = get_motion( cdf )
	    if Sketchup.active_model.entities.find{|e| e.is_a?(Sketchup::Face) }
		    @component_store[ cdf ] = export_entities( cdf )
			@instance_store.push [ cdf , t, "" , movec]
		end

		Sketchup.set_status_text "export main mesh end"
	    ents.find_all{|e| e.is_a?(Sketchup::Group) or e.is_a?(Sketchup::ComponentInstance) }.each{|g| export_ci(g, t , nil , movec) }
		
		wastetime = Time.now.to_f - @starttime
		Sketchup.set_status_text "All Mesh Stored:#{wastetime} sec"
		p "All Mesh Stored:#{wastetime} sec"

		export_stored_meshes()
		clear_storing_hashes()
	end
	def start_store_lights(ents = Sketchup.active_model.entities,t= Geom::Transformation.new)
		ents.find_all{|e| e.is_a?(Sketchup::Group) or e.is_a?(Sketchup::ComponentInstance) }.each{|g|
			next if g.hidden? == true or g.layer.visible? == false
			if g.is_a?(Sketchup::Group)
				cdf = g
			else
				cdf = g.definition
			end
			ot = t * g.transformation
			name = cdf.name
			if store_light_instance(name,g,ot) == false
				start_store_lights(cdf.entities,ot)
			end
		}
	end
	def store_light_instance(name,ci,ot)
		if ci.is_a?(Sketchup::ComponentInstance)
		if name == "T2H_PointLight"	
			dflightprops = default_light_props()
			pointlight_infos = {}
			dflightprops["pointlight"].each{|key,val|
				proptype = val[0]
				dfvalue = val[1]
				vallist = val[2]
				pointlight_infos[key] = ci.get_attribute("Mitsuba_light_setting",key,dfvalue)
			}
			pointlight_infos["type"] = "pointlight"
			otz = ot.zaxis
			otz.length = 25.mm
			pointlight_infos["position"] = ot.origin - otz
			@t2h_stored_lights.push pointlight_infos
			return true
		elsif name == "T2H_SPOTLIGHT"
			dflightprops = default_light_props()
			spotlight_infos = {}
			dflightprops["spotlight"].each{|key,val|
				proptype = val[0]
				dfvalue = val[1]
				vallist = val[2]
				spotlight_infos[key] = ci.get_attribute("Mitsuba_light_setting",key,dfvalue)
			}
			spotlight_infos["type"] = "spotlight"
			otz = ot.zaxis
			otz.length = 25.mm
			spotlight_infos["position"] = ot.origin - otz
			spotlight_infos["target"] = ot.origin - ot.zaxis
			@t2h_stored_lights.push spotlight_infos
			return true
		end
		end
		return false
	end
	def export_ci(ci, t = Geom::Transformation.new,mat = nil,movec=Geom::Vector3d.new(0,0,0))
		return if ci.hidden? == true or ci.layer.visible? == false
		
		if ci.is_a?(Sketchup::Group)
			cdf = ci
		else
			cdf = ci.definition
		end
		ot = t * ci.transformation
		defmate = mat
		defmate = ci.material if ci.material != nil

		@s2v_used_material.push defmate
		
		id = ci.entityID
		name = cdf.name
		name = "#{id}" if name.length == 0
		return if store_light_instance(name ,ci,ot) == true
		
		name.gsub!(/[\\\/]/,"_")

		matname = nil
		if defmate != nil
			matname = @matlist2[defmate]
		end
		matname = "" if matname == nil

		checker = false
		matnamelist = []
		movec2 = movec + get_motion( cdf , ot)
		if cdf.entities.find{|e| e.is_a?(Sketchup::Face)}
			if @component_store[ cdf ] == nil
				@component_store[ cdf ] = export_entities( cdf )
			end
			@instance_store.push [ cdf , ot , matname , movec2 ]
		end
		#@matnamelist[cdef] = matnamelist

		cdf.entities.find_all{|e| e.is_a?(Sketchup::Group) or e.is_a?(Sketchup::ComponentInstance) }.each{|f| export_ci(f,ot,defmate,movec2) }
	end
	def get_motion( cdf , ot = Geom::Transformation.new )
		motionlist = []
		motionlist = cdf.entities.find_all{|e| e.is_a?(Sketchup::ComponentInstance) and e.definition.name=="t2h_force_vector"}
		movec = Geom::Vector3d.new(0,0,0)
		if motionlist and motionlist != []
			motionlist.each{|mf|
				movec2 = Geom::Vector3d.new(0,0,1000.mm).transform( mf.transformation ).transform( ot )
				movec = movec + movec2
			}
		end

		return movec
	end
	def export_entities(cdf)
		entities = cdf.entities
		
		t = Geom::Transformation.new
		msh = Geom::PolygonMesh.new
		a6 = 1000000.0
		#vtscale = 1.inch.to_m.to_f * a6
		vtscale = a6
		meshes = {}
		vts = {}
		uvs = {}
		nos = {}
		vtcount = {}
		entities.find_all{|e| e.is_a?(Sketchup::Face) and ( e.hidden? == false or e.layer.visible? == true ) }.each{|e|
			bmat = nil
			mat = e.material
			mat = bmat = e.back_material if mat == nil
			@s2v_used_material.push mat if mat and @s2v_used_material.index(mat) == nil
			
			uscale = 1.0
			vscale = 1.0
			if mat
				matname = @matlist2[mat]
				if bmat
				elsif mat.texture
					uscale = 1.0 / mat.texture.width
					vscale = 1.0 / mat.texture.height
				end
			else
				matname = ""
			end
			
			meshes[matname] = [] if not meshes[matname]
			vts[matname] = "" if not vts[matname] 
			uvs[matname] = "" if not uvs[matname]
			nos[matname] = "" if not nos[matname]
			vtcount[matname] = 0 if not vtcount[matname]

			msh = e.mesh 5
			next if msh == nil

			time_check_status( "store meshes(#{matname})" , vtcount[matname] )
			
			(1..msh.count_points).each{|i|
				uv = msh.uv_at(i,1)
				uvs[matname] << "#{(uv.x / uscale * a6 ).round.to_f / a6 } #{(uv.y / vscale * a6 ).round.to_f / a6 } "
				nor = t * msh.normal_at(i)
				nor.normalize!
				nos[matname] << "#{( nor.x * a6 ).round.to_f / a6 } #{(nor.y * a6 ).round.to_f / a6 } #{(nor.z * a6 ).round.to_f / a6 } "
				vt = t * msh.points[i-1]
				vts[matname] << "#{( vt.x * vtscale ).round.to_f / a6 } #{( vt.y * vtscale ).round.to_f / a6 } #{( vt.z * vtscale ).round.to_f / a6  } "
			}
			meshes[matname] << msh.polygons.map{|p| p.map{|px| " #{px.abs + vtcount[matname] - 1} #{px.abs + vtcount[matname] - 1}" } }
			vtcount[matname] = vtcount[matname] + msh.count_points
			
			
		}#materials.each
		@matnamelist[cdf] = meshes.keys
		return meshes , vts , uvs , nos , vtcount
	end
	def numeric_prec( v )
		
	end
	def create_storing_hashes
	    mats = []
	    mats.push nil
		@matlist = Hash.new
		@matlist2 = Hash.new
	    Sketchup.active_model.materials.each{|mat|
	    	mats.push mat
			matname = ""
			if mat != nil
				matname = enc_kconv(mat.name)
			else
				matname = ""
			end
			@matlist[matname] = mat
			@matlist2[mat] = matname if mat
	    }

	end
	def clear_storing_hashes
		@matlist = nil
		@matlist2 = nil

	end
	def export_stored_meshes
		@mesh_start_index = {}
		@dae_objlist = []
		@objcount = 0
		i = 0
		@component_store.keys.each{|cdf|
			if cdf.is_a?(Sketchup::ComponentDefinition)
				objname = enc_kconv( cdf.name )
			elsif cdf.is_a?(Sketchup::Group)
				objname = "GROUP_" + cdf.entityID.to_s
			else
				objname = "MAIN"
			end
			@mesh_start_index[cdf] = i
			meshes , vts , uvs , nos , vtcount = @component_store[cdf]

			#meshes.delete_if{|key,msh| msh == [] }
			meshes.each_key{|matname|
				if matname == ""
					matname2 = "t2h_su2objmtl_default_material"
				else
					matname2 = matname
				end
				objname = objname + matname2
				export_object_file( objname , matname, meshes[matname],vts[matname],uvs[matname],nos[matname], vtcount[matname] )
				i += 1
			}
		}
		@component_store = nil
	end
def point_add( vec1 , vec2 )
	Geom::Point3d.new( vec1.x.to_f + vec2.x.to_f , vec1.y.to_f + vec2.y.to_f , vec1.z.to_f + vec2.z.to_f )
end

def vector_add( vec1 , vec2 )
	Geom::Vector3d.new( vec1.x.to_f + vec2.x.to_f , vec1.y.to_f + vec2.y.to_f , vec1.z.to_f + vec2.z.to_f )
end

def vector_subtract( vec1 , vec2 )
	Geom::Vector3d.new( vec1.x.to_f - vec2.x.to_f , vec1.y.to_f - vec2.y.to_f , vec1.z.to_f - vec2.z.to_f )
end

def vector_scale( vec1 , tf )
	Geom::Vector3d.new( vec1.x.to_f * tf.to_f , vec1.y.to_f * tf.to_f , vec1.z.to_f * tf.to_f )
end
	def explode_images()
		dfs = Sketchup.active_model.definitions
		chk = false
		Sketchup.active_model.start_operation("explode images",true)
		dfs.each{|df|
			df.instances.each{|ci|
				if ci.is_a?(Sketchup::Image)
					ci.explode
					#if chk == false
					#	fc1 = df.entities.find{|e| e.is_a?(Sketchup::Face)}
					#	if fc1
					#		props ,coatprops,lightprops,dipoleprops = get_prop_from_material(fc1.material)
					#	end
					#	grp=ci.parent.entities.add_group(ci)
					#	ci.explode
					#	fc2 = grp.entities.find{|e| e.is_a?(Sketchup::Face)}
					#	if fc2 and fc1
					#		save_mat_props(fc2.material,props ,coatprops,lightprops,dipoleprops)
					#	end
					#	grp.explode
					#else
					#	ci.explode
					#end
					chk = true
				else
					break
				end
			}
		}
		Sketchup.active_model.commit_operation
		return chk
	end

	def export_textures( cm_only = "" )
		txpts = []
		txpts.push [0, 0, 0]
		txpts.push [0, 1, 0]
		txpts.push [1, 1, 0]
		txpts.push [1, 0, 0]
		Sketchup.active_model.start_operation "texture export",true
		txgrp = Sketchup.active_model.entities.add_group
		txfc = txgrp.entities.add_face txpts
		savenames = []
		texnames_bymat = Hash.new
		if cm_only == ""
			Sketchup.active_model.materials.each{|mat|
				if mat.texture != nil
					txfc.material = mat
					@s2v_model_textures.push([mat, txfc , true ])
					savename = enc_kconv(File.basename(mat.texture.filename.to_s))
					savename2 = get_uniqname( savenames ,savename.downcase )
					savenames.push savename2
					#@texnames_bymat[mat.name] = savename2
					export_tex( txfc ,savename2 ,true )
					texnames_bymat[mat.name] = savename2
				end
			}
		else#カレントマテリアルのみを判定
			mat = Sketchup.active_model.materials.current
			if mat and mat.texture != nil
				txfc.material = mat
				savename = enc_kconv(File.basename(mat.texture.filename.to_s))
				#@texnames_bymat[mat.name] = savename
				export_tex( txfc ,savename ,true )
				texnames_bymat[mat.name] = savename 
			end
		end
		#Sketchup.active_model.entities.erase_entities txgrp
		Sketchup.active_model.commit_operation
		Sketchup.undo
		Sketchup.set_status_text "Exporting texture end"
		@texnames_bymat = Hash.new
		texnames_bymat.each{|key,val|
			chk = is_png_use_alpha(val)
			@texnames_bymat[key] = [ val , chk ]
		}
	end

	def export_tex( ent ,filename , forb = true )
		tw = Sketchup.create_texture_writer
		status = tw.load(ent,forb)
		if status > 0
			tw.write( ent, forb , File.expand_path(File.join(@texture_exportpath,filename)))
		end
	end
	def is_png_use_alpha(filename)
		#filename = "C:\\freeware\\Mitsuba 0.5.0\\su_render\\tx_default\\chair.png"
		if File.extname(filename).upcase != ".PNG"
			return false
		end
		filepath = File.expand_path(File.join(@texture_exportpath,filename))
		if not File.exists?( filepath )
			return false
		end
		image = open(filepath, "rb")
		signature   = image.read(8)
		data_length = image.read(4).unpack(">N")[0]
		chunk_name  = image.read(4)
		#chunk       = image.read(data_length)
		width       = image.read(4).unpack(">N")[0]
		height      = image.read(4).unpack(">N")[0]
		bit_depth   = image.read(1).unpack("h")[0].to_i
		color_type  = image.read(1).unpack("h")[0].to_i
		#compression = image.read(1).unpack("h")[0].to_i
		#filter      = image.read(1).unpack("h")[0].to_i
		#interlace   = image.read(1).unpack("h")[0].to_i
		image.close
		if color_type == 4 or color_type == 6
			return true
		else
			return false
		end
	end
	def get_uniqname( savenames =[] ,savename = "" )
		if savenames.index(savename)
			cnt = 1
			while cnt < 1000
				newname = File.basename(savename,".*") + cnt.to_s + File.extname(savename)
				return(newname) if savenames.index(newname) == nil
				cnt += 1
			end
		end
		return savename
	end

	def enc_kconv(str = "")

		return nil if str ==nil
		return "" if str == ""
		new_str = str.gsub(/[\\\/:*?\"\'\{\}\#<>|+="#" %&]/,"_")
		
		new_str.gsub!(/[\[\]]/,"_")
		new_str.gsub!(/[\(\)\,]/,"_")

		japcount = 0
		japcount = new_str.scan(/([^-\._A-Za-z0-9])/).length.to_i if new_str[/[^-\._A-Za-z0-9]/] != nil
		(0..japcount).each{|i|
			new_str.sub!(/([^-\._A-Za-z0-9])/, int2logos($1) )
		}

	  return new_str
	end
	def int2logos(tstr = "")
		return "" if tstr ==nil
		return "" if tstr == ""
		i = tstr.unpack("U*")[0].to_i- 10000
		return "" if i < 0
		new_str = "_"
		#logos="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
		logos="0123456789abcdefghijklmnopqrstuvwxyz"
		dm = []
		(0..10).each{|n|
			dm = i.divmod(logos.length.to_i + 1)
			new_str = new_str + logos[dm[1]-1].chr if not dm[1] == 0
			if dm[0] == 0
				return new_str
			else
				i = dm[0]
			end
		}
	end


	def camera_aspect_zero()
		camera = Sketchup.active_model.active_view.camera
		p_aspect = camera.aspect_ratio
		camera.aspect_ratio = 0.0
		p_flength = camera.focal_length
		camera.focal_length = p_flength * p_aspect if p_aspect != 0.0
	end
	
	def array_add( arr1 , arr2 )
		arr3 = []
		(1..arr1.size).each{|cnt|
			arr3[cnt-1] = arr1[cnt-1].to_f + arr2[cnt-1].to_f if arr2[cnt-1] != nil
		}
		return arr3
	end
	def array_subtract( arr1 , arr2 )
		arr3 = []
		(1..arr1.size).each{|cnt|
			arr3[cnt-1] = arr1[cnt-1].to_f - arr2[cnt-1].to_f if arr2[cnt-1] != nil
		}
		return arr3
	end
	def array_product( arr1 , flo )
		arr3 = []
		(1..arr1.size).each{|cnt|
			arr3[cnt-1] = arr1[cnt-1].to_f * flo.to_f
		}
		return arr3
	end
	def calc_sec_modify( sech1, sech2, frame , nextframe , prevframe )
		fps = nextframe -  prevframe
		cframe = frame - prevframe
		arr1 = array_product( sech1 , ( ( fps.to_f - cframe.to_f ) / fps.to_f ) )
		arr2 = array_product( sech2 , ( cframe.to_f / fps.to_f ) )
		arr3 = array_add( arr1 , arr2 )
		return arr3
	end
end#of module
end#module
end#module